/**
 *     Copyright (C) 2009-2011  Jack A. Rider All rights reserved.
 * 
 *     This program is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 * 
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 */
 
 package org.xmlportletfactory.portal.goodclient.service.impl;

import java.util.List;

import org.xmlportletfactory.portal.goodclient.model.users;
import org.xmlportletfactory.portal.goodclient.service.base.usersLocalServiceBaseImpl;
import org.xmlportletfactory.portal.goodclient.service.persistence.usersUtil;
import com.liferay.counter.service.CounterLocalServiceUtil;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.dao.orm.QueryUtil;

import com.liferay.portlet.documentlibrary.service.DLFolderLocalServiceUtil;
import com.liferay.portlet.imagegallery.service.IGFolderLocalServiceUtil;
import com.liferay.portal.kernel.exception.PortalException;

/**
 * @author Jack A. Rider
 */
public class usersLocalServiceImpl extends usersLocalServiceBaseImpl {

	@SuppressWarnings("unchecked")
	public List findAllInUser(long userId)throws SystemException {
		List<users> list = (List<users>) usersUtil.findByUserId(userId);
		return list;
	}

	@SuppressWarnings("unchecked")
	public List findAllInUser(long userId, OrderByComparator orderByComparator) throws SystemException {
		List<users> list = (List<users>) usersUtil.findByUserId(userId, QueryUtil.ALL_POS,QueryUtil.ALL_POS, orderByComparator);
		return list;
	}

	@SuppressWarnings("unchecked")
	public List findAllInGroup(long groupId) throws SystemException {
		List<users> list = (List<users>) usersUtil.findByGroupId(groupId);
		return list;
	}

	@SuppressWarnings("unchecked")
	public List findAllInGroup(long groupId, OrderByComparator orderByComparator) throws SystemException{
		List <users> list = (List<users>) usersUtil.findByGroupId(groupId,QueryUtil.ALL_POS,QueryUtil.ALL_POS, orderByComparator);
		return list;
	}

	@SuppressWarnings("unchecked")
	public List findAllInUserAndGroup(long userId, long groupId) throws SystemException {
		List<users> list = (List<users>) usersUtil.findByUserIdGroupId(userId, groupId);
		return list;
	}

	@SuppressWarnings("unchecked")
	public List findAllInUserAndGroup(long userId, long groupId, OrderByComparator orderByComparator) throws SystemException {
		List<users> list = (List<users>) usersUtil.findByUserIdGroupId(userId, groupId, QueryUtil.ALL_POS, QueryUtil.ALL_POS, orderByComparator);
		return list;
	}





	public users addusers (users validusers) throws SystemException {
	    users fileobj = usersUtil.create(CounterLocalServiceUtil.increment(users.class.getName()));

	    fileobj.setCompanyId(validusers.getCompanyId());
	    fileobj.setGroupId(validusers.getGroupId());
	    fileobj.setUserId(validusers.getUserId());

	    fileobj.setUserName(validusers.getUserName());
		fileobj.setUserPhoto(validusers.getUserPhoto());
		fileobj.setFolderIGId(validusers.getFolderIGId());

	    return usersUtil.update(fileobj, false);
	}

	public void deleteusers (users fileobj) throws SystemException {
		//Remove imageFile dir
		Long igFolder = fileobj.getFolderIGId();
		if((igFolder!=null) && (igFolder!=0L)) {
			try {
				IGFolderLocalServiceUtil.deleteFolder(igFolder);
			} catch (PortalException ex) {
				throw new SystemException (ex.getMessage(),ex.getCause());
			}
		}
		usersUtil.remove(fileobj);
	}

	public void remove(users fileobj) throws SystemException {
	    usersUtil.remove(fileobj);
	}
}